# -*- coding: utf-8 -*-
"""
Created on Sat May 23 12:33:57 2020

@author: F. Jetzinger
"""

from graphics_and_games_klassen import Rechteck, Figur
from intern.zeichenfenster import Zeichenfenster

class Catwalk():
    """
    Klasse zur Beschreibung des Catwalks
    """
    
    def __init__(self):
        """
        Der Konstruktor des Catwalks legt die Leuchten an
        """
        self.farbe = "blau"
        self.breite = 40
        self.spaltenanzahl = 10
        self.leuchten = []
        self.farben = []
        for spalte in range(self.spaltenanzahl):
                self.leuchten.append(Rechteck())
                self.leuchten[spalte].GroesseSetzen(self.breite, self.breite)
                self.leuchten[spalte].PositionSetzen(40+spalte*self.breite, 50)
                print("position:" + str(self.leuchten[spalte].x))
                if(self.farbe == "blau"):
                    self.farbe = "rot"
                else:
                    self.farbe = "blau"
                self.farben.append(self.farbe);
                self.leuchten[spalte].FarbeSetzen(self.farbe);
                
        
        
    def FarbeSetzen(self, spalte, farbe):
        """
        Setzt die angegebene Leuchte auf die gewünschte Farbe
        -- Parameter spalte die Spaltennummer der Leuchte
        -- Parameter farbe die gewünschte Farbe
        """
        self.leuchten[spalte].FarbeSetzen(farbe)
        self.farben[spalte]=farbe
        
    def FarbeGeben(self, spalte):
        """
        Gibt die Farbe der angegebene Leuchte
        --- Parameter spalte die Spaltennummer der Leuchte
        --- return die Farbe der gewünschten Leuchte
        """
        return self.farben[spalte]
    
    def SpaltenanzahlGeben(self):
        """
        Meldet die Anzahl der Leuchten
        --- return Leuchtenanzahl
        """
        return self.spaltenanzahl


class CatwalkSteuerung(Figur):
    """
    Steuerung der Leuchten auf dem Dancefloor
    """
    
    def __init__(self):
        """
        Legt den Laufsteg und den Zufallsgenerator an.
        """
        super().__init__()
        self.laufsteg =  Catwalk()
        self.SichtbarkeitSetzen(False)
        self.zaehler = 0
        
    def AktionAusfuehren(self):
        """
        Lässt die Farben eine Spalte weiter laufen
        """
        for spalte in range(self.laufsteg.SpaltenanzahlGeben()):
            self.laufsteg.FarbeSetzen(spalte, self.NaechsteFarbeGeben())
            Zeichenfenster().Darstellen()
            
    def NaechsteFarbeGeben(self):
        """
        Bestimmt die nächste Farbe
        -- return nächste Farbe
        """
        self.zaehler = (self.zaehler + 1) % 12
        if self.zaehler == 0:
            farbe = 'weiss'
        elif self.zaehler == 1:
            farbe = "rot"
        elif self.zaehler == 2:
            farbe = "grün" 
        elif self.zaehler == 3:
            farbe = "blau"
        elif self.zaehler == 4:
            farbe = "gelb"
        elif self.zaehler == 5:
            farbe = "magenta"
        elif self.zaehler == 6:
            farbe = "cyan"
        elif self.zaehler == 7:
            farbe = "hellgelb"
        elif self.zaehler == 8:
            farbe = "hellgrün"
        elif self.zaehler == 9:
            farbe = "orange"
        elif self.zaehler == 10:
            farbe = "braun"
        elif self.zaehler == 11:
            farbe = "grau"
        else:
            farbe = "schwarz"
        return farbe
    
c = CatwalkSteuerung()