# -- coding: utf-8 --
"""
Created on Wed Apr  8 17:53:04 2020
@author: Klaus Reinold
"""

from graphics_and_games_klassen import Figur, Text

class Monster(Figur):
    """
    Verwaltet das Monster
    """
    
    def __init__(self):  
        """
        Legt die Figur und die Munstellung fest.
        """    
        super().__init__()
        self.anzahl = 0
        self.mundIstZu = True
        self.Schliessen("gelb")
        
    def GeschlossenGelb(self):
        """
        Stellt das gelb gefärbte Monster mit geschlossenem Mund dar.
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "gelb")
        self.FigurteilFestlegenRechteck(0, -2, 50, 4, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def GeschlossenOrange(self):
        """
        Stellt das orange gefärbte Monster mit geschlossenem Mund dar.
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "orange")
        self.FigurteilFestlegenRechteck(0, -2, 50, 4, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def GeschlossenRot(self):
        """
        Stellt das rot gefärbte Monster mit geschlossenem Mund dar.
        """   
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "rot")
        self.FigurteilFestlegenRechteck(0, -2, 50, 4, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def GeschlossenGruen(self):
        """
        Stellt das grün gefärbte Monster mit geschlossenem Mund dar.
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "grün")
        self.FigurteilFestlegenRechteck(0, -2, 50, 4, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def Offen(self, farbe):
        """
        Stellt das Monster in der angegebenen Farbe mit offenem Mund dar.
        -- Parameter farbe die gewünschte Farbe
        """    
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, farbe)
        self.FigurteilFestlegenDreieck(0, 0, 50, -10, 50, 10, "schwarz")
        self.FigurteilFestlegenEllipse(10, -40, 20, 20, "schwarz")
        
    def Schliessen(self, farbe):
        """
        Stellt das in einer der Farben gelb, orange, rot bzw. grün mit geschlossenem Mund dar.
        -- Parameter farbe die gewünschte Farbe
        """    
        if farbe == "gelb": 
            self.GeschlossenGelb()
        if farbe == "orange":
            self.GeschlossenOrange()
        if farbe == "rot":
            self.GeschlossenRot()
        if farbe == "grün":
            self.GeschlossenGruen()
            
    def Oeffnen(self, farbe):
        """
        Stellt das in einer der Farben gelb, orange, rot bzw. grün mit offenem Mund dar.
        -- Parameter farbe die gewünschte Farbe
        """    
        if farbe == "gelb" or farbe == "orange" or farbe == "rot" or farbe == "grün":
            self.Offen(farbe)
            
    def TasteGedrueckt (self, taste):
        """
        Die Aktionsmethode für gedrückte Tasten.
        -- Parameter taste KeyCode der gedrückten Taste
        """    
        if taste == "left":        
            self.WinkelSetzen(180)
        elif taste == "up":            
            self.WinkelSetzen(90)
        elif taste == "right":
            self.WinkelSetzen(0)
        elif taste == "down":
            self.WinkelSetzen(270)
            
    def AktionAusfuehren(self):
        """
        Das Monster geht maximal bis zum Rand
        """
        if self.mundIstZu:
            self.Oeffnen("gelb")
            self.mundIstZu = False
        else:
            self.Schliessen("gelb")
            self.mundIstZu = True
        if self.WinkelGeben() == 0:
            if self.XPositionGeben()< 790:
                self.Gehen(10)   
            else:
                Verloren()
        elif self.WinkelGeben() == 90:
            if self.YPositionGeben()> 30:
                self.Gehen(10)
            else:
                Verloren()
        elif self.WinkelGeben() == 180:
            if self.XPositionGeben()> 10:
                self.Gehen(10)
            else:
                Verloren()
        elif self.WinkelGeben() == 270:
            if self.YPositionGeben()< 500:
                self.Gehen(10)
            else:
                Verloren()
        if self.BeruehrtFarbe("orange"):
           self.anzahl = self.anzahl + 1
        if self.anzahl == 10:
            Gewonnen()
            
class Kruemel(Figur):
    """
    Verwaltet einen Krümel
    """
    
    def __init__(self, x, y):
        """
        Legt Position und Figur fest
        -- Parameter x x-Position des Krümels
        -- Parameter y y-Position des Krümels
        """    
        super().__init__()
        self.FigurFestlegen()
        self.PositionSetzen(x, y)
        
    def FigurFestlegen(self):  
        """
        Stellt den orangen Krümel dar.
        """   
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenEllipse(-5, -5, 10, 10, "orange")
        
    def AktionAusfuehren(self):  
        """
        Der Krümel verschwindet bei Berührung
        """    
        if self.Beruehrt():
            self.Entfernen()
            
class AlleKruemel:
    """
    Erzeugung aller Krümel
    """
    
    def __init__(self):  
        """
        Erzeugung aller Krümel
        """   
        Kruemel(600, 50)
        Kruemel(150, 200)
        Kruemel(400, 30)
        Kruemel(500, 300)
        Kruemel(250, 140)
        Kruemel(180, 560)
        Kruemel(300, 270)
        Kruemel(330, 420)
        Kruemel(110, 70)
        Kruemel(330, 490)
        Kruemel(470, 120)
        
class Verloren(Text):
    """
    Stellt den Verlusttext dar
    """
    def __init__(self):  
        """
        Legt Position und Text fest
        """
        super().__init__()
        self.TextSetzen("Du hast verloren")
        self.PositionSetzen(700, 20)
        
class Gewonnen(Text):
    """
    Stellt den Gewinntext dar
    """
    
    def __init__(self):  
        """
        Legt Position und Text fest
        """   
        super().__init__()
        self.TextSetzen("Du hast das Spiel gewonnen")
        self.PositionSetzen(10, 20)
        
AlleKruemel()
Monster()
