# -- coding: utf-8 --
"""
Created on Wed Apr  8 17:53:04 2020
@author: Klaus Reinold
"""

from random import randint
from graphics_and_games_klassen import Figur, Rechteck, Dreieck, Kreis, Ereignisbehandlung

class SpielFigur(Figur):
    """
    Die Spielfigur der verueckten Reise
    """
    
    def __init__(self, winkel):
        """
        Der Startpunkt ist die Mitte des Feldes.
        -- Parameter winkel die Blickrichtung beim Start
        """    
        super().__init__()
        self.PositionSetzen(400, 250)
        self.WinkelSetzen(winkel)
        
    def AktionAusfuehren(self):
        """
        Bewegt die Figur
        """    
        if self.BeruehrtFarbe("schwarz"):
            self.Drehen(180)
            self.Gehen(40)
        elif self.BeruehrtFarbe("rot"):
            self.Drehen(5)
            self.Gehen(5)
        elif self.BeruehrtFarbe("grün"):
            self.Drehen(-10)
            self.Gehen(5)
        elif self.BeruehrtFarbe("blau"):
            self.Drehen(15)
            self.Gehen(10)
        elif self.BeruehrtFarbe("gelb"):
            self.Drehen(-5)
            self.Gehen(10)
        else:
            self.Gehen(15)
            
    def TasteGedrueckt(self, taste):
        """
        Steuert die Richtung der Spielfigur.
        -- Parameter taste KeyCode der gedrückten Taste
        """    
        if taste == "left":
            self.Drehen(5)
        elif taste == "right":
            self.Drehen(-5)
            
SpielFigur(0)
