# -- coding: utf-8 --
"""
Created on Wed Apr  8 17:53:04 2020
@author: Klaus Reinold
"""

from graphics_and_games_klassen import Figur, Rechteck, Kreis

class Baum(Figur):
    
    def __init__(self):  
        """
        Legt die benötigten Objekte an.
        """   
        super().__init__()
        self.himmel = Rechteck()
        self.boden = Rechteck()
        self.stamm = Rechteck()
        self.krone = Kreis()
        self.himmel.FarbeSetzen("blau")
        self.himmel.GroesseSetzen(800,300)
        self.himmel.PositionSetzen(0,0)
        self.boden.FarbeSetzen("gruen")
        self.boden.GroesseSetzen(800,300)
        self.boden.PositionSetzen(0,300)
        self.stamm.FarbeSetzen("braun")
        self.groesse = 100
        self.stamm.GroesseSetzen(30,self.groesse)
        self.stamm.PositionSetzen(385,380-self.groesse)
        self.krone.PositionSetzen(400,300-(2*self.groesse/3))  
        self.krone.RadiusSetzen(self.groesse/2)
        self.jahreszeit = "Fruehling"
        self.FruehlingSetzen()
        
    def WinterSetzen(self):  
        """
        Stellt den Baum im Winter dar
        """   
        self.jahreszeit = "Winter"
        self.krone.FarbeSetzen("weiss")
        
    def FruehlingSetzen(self):  
        """
        Stellt den Baum im Frühling dar
        """    
        self.jahreszeit = "Fruehling"
        self.krone.FarbeSetzen("hellgruen")
        
    def SommerSetzen(self):  
        """
        Stellt den Baum im Sommer dar
        """   
        self.jahreszeit = "Sommer"
        self.krone.FarbeSetzen("gruen")
        
        
    def HerbstSetzen(self):  
        """
        Stellt den Baum im Herbst dar
        """    
        self.jahreszeit = "Herbst"
        self.krone.FarbeSetzen("orange")
        
    def Wachsen(self):  
        """
        Lässt den Baum wachsen
        """   
        self.groesse = self.groesse+4
        self.stamm.GroesseSetzen(30,self.groesse)
        self.stamm.PositionSetzen(385,380-self.groesse)
        self.krone.PositionSetzen(400,300-(2*self.groesse/3))
        self.krone.RadiusSetzen(self.groesse/2)
        
    def AktionAusfuehren(self):  
        """
        Der Baum tut nichts automatisch
        """   
        pass
    
Baum()
